# -*- coding: utf-8 -*-
# Generated by Django 1.11.6 on 2019-11-18 23:29
from __future__ import unicode_literals

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [("customers", "0002_auto_20191104_1841")]

    sql = """
    CREATE VIEW customers_financialrecord AS SELECT 'I' || id::text as record_id, paid AS paid, due_date AS ts, CASE WHEN kind != 3 THEN total END AS charge, CASE WHEN kind = 3 THEN total END AS credit, comment, customer_id FROM customers_invoice UNION SELECT 'P' || id::text as record_id, TRUE as paid, paid_on AS ts, NULL AS charge, amount AS credit, comment, customer_id FROM customers_payment ORDER BY ts DESC
    """

    balance_sql = """
    CREATE VIEW customers_balance AS SELECT C.id as id, C.id as customer_id, COALESCE(SUM(FR.credit), 0)-COALESCE(SUM(FR.charge), 0) AS balance FROM customers_customer C LEFT JOIN customers_financialrecord FR ON C.id = FR.customer_id GROUP BY id
    """
    operations = [
        migrations.RunSQL("DROP VIEW IF EXISTS customers_balance"),
        migrations.RunSQL("DROP VIEW IF EXISTS customers_financialrecord"),
        migrations.RunSQL(sql),
        migrations.RunSQL(balance_sql),
    ]
